/* a predicate which contains Prolog cuts in its clauses */

test(X) :-
   p(X),
   !,
   foo(X).
test(42) :-
   r(X),
   !,
   writeln('hello').
test(50).

/* gets transformed by the compiler to the following:

test(X) :-
   '_$savecp'(B),
   '_$test#303'(X,B).

'_$test#303'(X,B) :-
   p(X),
   '_$cutto'(B),
   foo(X).
'_$test#303'(42,B) :-
   r(X),
   '_$cutto'(B),
   writeln('hello').
'_$test#303'(50,_).

-----------------------------------------------------------*/

/* in contrast, a predicate with JET pruning operators */

t(X) :-
   p(X),
   !!,
   foo(X).
t(42) :-
   r(X),
   !!,
   writeln('hello').
t(50).

/* needs to get transformed by the compiler to the following:

t(X) :-
   '_$savecp'(B),
   p(X),
   'JET'(B),
   foo(X).
t(42) :-
   '_$savecp'(B),
   r(X),
   'JET'(B),
   writeln('hello').
t(50).

 */

/* THINGS THAT NEED TO BE DONE:

 1. See how '!' is implemented in the lexer & parser and add a '!!'

 2. See how '!' is translated by preproc.P and introduce a similar
    transformation for '!!'

 3. The handling of '_$savecp'/1 should be (is?) already present in
    the compiler.  'JET'/1 should be translated away if you have it
    as a builtin in builtin.P.  You might need to convince the XXX
    compiler that 'JET'/1 is indeed a new builtin that needs to be
    handled similarly to other inline predicates (since '_$cutto'/1
    is known to be an inline predicate, while 'JET'/1 is not).

It is probably easier to inspect what happens if you generate a .A
file by using

	compile(prog, [asm_dump]).

*/
