/* File:      biassert.h
** Author(s): Kostis Sagonas
** Contact:   kostis@csd.uu.se
** 
** Copyright (C) Kostis Sagonas, 2000
** 
** XSB is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** XSB is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with XSB; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** $Id: biassert.h,v 1.3 2006/08/21 11:40:48 kostis Exp $
** 
*/

/*----------------------------------------------------------------------*/
/* Clause References -- needs to be here because it is used below.      */

typedef struct ClRefHdr {
  unsigned long buflen ;
  struct ClRefHdr *prev ;
} *ClRef, ClRefHdr;

/*----------------------------------------------------------------------*/

extern bool db_get_clause(ClRef);
extern bool db_retract_clause(ClRef,int);
extern bool db_assert_code_to_buff(Cell);
extern bool db_retract_abolish(Cell,bool);
extern bool db_convert_to_dynamic(Cell,bool);
extern bool db_assert_buff_to_clref(Cell,int,Cell,int);

extern bool trie_assert(Cell,bool);
extern bool trie_retract(CPtr);
extern bool trie_retract_safe(void);
extern bool is_trie_asserted(ClRef);

extern byte *jiti_create_htable_asserts(byte *,Integer,Integer);
extern Integer get_clauseno(byte *);

/*----------------------------------------------------------------------*/

#define switch_to_trie_assert {		\
  smBTN = &smAssertBTN;			\
  smBTHT = &smAssertBTHT;		\
}

#define switch_from_trie_assert {	\
  smBTN = &smTableBTN;			\
  smBTHT = &smTableBTHT;		\
}

/*----------------------------------------------------------------------*/
