/* File:      bineg_xsb_i.h
** Author(s): Kostis Sagonas, Baoqiu Cui
** Contact:   xsb-contact@cs.sunysb.edu
** 
** Copyright (C) The Research Foundation of SUNY, 1986, 1993-1998
** 
** XSB is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** XSB is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with XSB; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** $Id: bineg_xsb_i.h,v 1.5 2003/11/23 22:24:23 kostis Exp $
** 
*/


/*----------------------------------------------------------------------*/

#ifdef DEBUG_DELAY
#define IS_INCOMPLETE_DEBUG_1(SUBG_PTR) \
    fprintf(stddbg, "Is incomplete for ");                        \
    print_subgoal(stddbg, SUBG_PTR);                              \
    fprintf(stddbg,", (%x)\n",(int)&subg_ans_root_ptr(SUBG_PTR))
#define IS_INCOMPLETE_DEBUG_2(SUBG_PTR,T_PTCP) \
    fprintf(stddbg, "... Saving a completion suspension (~");     \
    print_subgoal(stddbg, SUBG_PTR);                              \
    fprintf(stddbg, " in the body of ");                          \
    if (t_ptcp != NULL) {                                         \
       print_subgoal(stddbg, (SGFrame)T_PTCP);                    \
    } else fprintf(stddbg, "an UNTABLED predicate");              \
    fprintf(stddbg, ")\n")

#else

#define IS_INCOMPLETE_DEBUG_1(SUBG_PTR)
#define IS_INCOMPLETE_DEBUG_2(SUBG_PTR,T_PTCP)
#endif

/*----------------------------------------------------------------------*/
/* Contains builtin predicates for SLG negation (and tfindall/3).	*/
/*----------------------------------------------------------------------*/

    case SLG_NOT: {	/* reg1: +SubgoalPtr */
      SGFrame subgoal_ptr = (SGFrame)ptoc_addr(1);
      if (has_no_answers(subgoal_ptr) &&
	  (is_completed(subgoal_ptr) || neg_delay == FALSE)) {
	return TRUE;
      }
      if (has_unconditional_answers(subgoal_ptr)) {
	return FALSE;
      } else {
	delay_negatively(subgoal_ptr);
	return TRUE;
      }
    }

/*----------------------------------------------------------------------*/

    case IS_INCOMPLETE: { /* reg1: +term; reg2: +SubgoalPtr;	*/
			  /* reg3: +PTCP; reg4: -SubgPtr        */
      Cell    term = ptoc_tag(1);
      SGFrame subgoal_ptr = (SGFrame)ptoc_addr(2);
      CPtr    t_ptcp = (CPtr)ptoc_addr(3);

      if (subgoal_ptr == NULL) {
	TIFptr tip;
	Psc    psc = term_psc(term);
	if ((tip = get_tip(psc)) == NULL) {
	  xxx_abort("Predicate %s/%d is not tabled",
		    get_name(psc), get_arity(psc));
	}
	subgoal_ptr = get_subgoal_ptr(term, tip);
      }
      ctop_addr(4, subgoal_ptr);
      IS_INCOMPLETE_DEBUG_1(subgoal_ptr);
      if (is_completed(subgoal_ptr)) {
	neg_delay = FALSE;
	ptcpreg = t_ptcp;  /* restore ptcpreg as the compl. suspens. would */
	return TRUE;	/* succeed */
      }
      else {	/* subgoal is not completed; save a completion suspension */
	IS_INCOMPLETE_DEBUG_2(subgoal_ptr,t_ptcp);
	adjust_level(subg_compl_stack_ptr(subgoal_ptr));
	save_find_locx(ereg);
	subg_compl_susp_ptr(subgoal_ptr) = (CPtr)
	  save_a_chat_compl_susp(subgoal_ptr, t_ptcp, cpreg);
	return FALSE;
      }
    }

/*----------------------------------------------------------------------*/

    case GET_PTCP:
      ctop_addr(1, ptcpreg);
      break;

/*----------------------------------------------------------------------*/

    case GET_DELAY_LISTS:
      get_delay_lists(
#if defined(CST_SUPPORT)
	  (CST)
#else
	  (BTNptr)
#endif
	  ptoc_addr(1), ptoc_tag(2));
      break;

/*----------------------------------------------------------------------*/

