/* File:      bldval.h
** Author(s): Kostis Sagonas
** Contact:   kostis@csd.uu.se
** 
** Copyright (C) Kostis Sagonas, 2000
** 
** XSB is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** XSB is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with XSB; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** $Id: bldval.h,v 1.1.1.1 2001/06/13 16:41:14 kostis Exp $
** 
*/


/* --- for building vals on the heap ---------------------------------- */

inline static void bld_val(Cell op)
{
  deref2(op, goto bld_val_op_free);
  new_heap_node(hreg, op);
  return;
  
 bld_val_op_free:
  /* The correct condition for the following test is
  **       (CPtr)op >= glstack.low && (CPtr)op <= top_of_heap
  ** but the first part is a WAM invariant and the second is hacked for speed.
  */
  if ((CPtr)op < hreg) { new_heap_node(hreg, op); }
  else
    { /* local stack vars point to heap vars and not vice-versa! */
      bind_ref((CPtr)op, hreg);
      new_heap_free(hreg);
    }
}

/* -------------------------------------------------------------------- */
