/* File:      complete_xsb_i.h
** Author(s): Kostis Sagonas, Terry Swift, Juliana Freire
** Contact:   xsb-contact@cs.sunysb.edu
** 
** Copyright (C) The Research Foundation of SUNY, 1986, 1993-1998
** 
** XSB is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** XSB is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with XSB; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** $Id: complete_xsb_i.h,v 1.2 2003/03/17 14:18:11 kostis Exp $
** 
*/

/*----------------------------------------------------------------------*/

case check_complete:
check_complete_label:
{
  SGFrame         subgoal;
  ComplStackFrame cs_ptr;

  /* this CP has exhausted program resolution -- backtracking occurs */
  undo_bindings(breg);
  ptcpreg = tcp_ptcp(breg);
  delayreg = tcp_pdreg(breg);
  restore_some_wamregs(breg, ereg);

  subgoal = (SGFrame)tcp_subgoal_ptr(breg);	/* subgoal that is checked */

#ifdef DEBUG_DELAY
  fprintf(stderr, ">>>> check_complete is called.  The checked subgoal is: ");
  print_subgoal(stderr, subgoal); fprintf(stderr, "\n");
#endif

  cs_ptr = subg_compl_stack_ptr(subgoal);

  if (is_leader(cs_ptr))
    {
      CPtr tmp_breg;
      /* check if reached fixpoint, o/w schedule any unresolved answers */
      if ((tmp_breg = chat_fixpoint(subgoal)))
	{
	  breg = tmp_breg;
	  Fail1;
	  MoreMoreYesGimmeMore;
	}
      else
	{
	  CPtr    orig_breg = breg;
	  SGFrame compl_subg; /* subgoal to be completed */
	  ComplStackFrame ComplStkFrame = cs_ptr;
      
	  /* check from leader up to the youngest subgoal */
	  while (ComplStkFrame >= openreg) {
	    compl_subg = compl_subgoal_ptr(ComplStkFrame);
	    if (is_completed(compl_subg)) { /* this was early completed */
	      chat_free_compl_susp_chat_areas(compl_subg);
	    }
	    else { /* if not early completed */
	      CPtr nsf;
	      if ((nsf = subg_compl_susp_ptr(compl_subg)) != NULL) { 
		CPtr p, prev_nsf = NULL;
		/* check each suspension frame for appropriate action: if
		   their parents are completed these completion suspensions
		   fail, so forget about them; o/w delay them and let
		   simplification take care of the rest */
		while (nsf) {
		  if ((p = csf_ptcp(nsf)) != NULL) {
		    if (is_completed(p)) {
		      if (!prev_nsf) { /* deleting the first susp is special */
			nsf = subg_compl_susp_ptr(compl_subg) =
			  chat_free_compl_susp_chat_area((chat_init_pheader)nsf);
		      }
		      else {
			nsf = csf_prevcsf(prev_nsf) =
			  chat_free_compl_susp_chat_area((chat_init_pheader)nsf);
		      }
		    }
		    else { /* this completion suspension will be delayed */
		      mark_neg_loop(nsf);
		      prev_nsf = nsf;
		      nsf = csf_prevcsf(nsf);
		    }
		  }
		} /* while */
		if ((nsf = subg_compl_susp_ptr(compl_subg))) {
		  CPtr H = cp_hreg(breg);
		  CPtr EB = cp_ebreg(breg);
		  
		  breg = chat_restore_compl_susp((chat_init_pheader)nsf, H,EB);
		  subg_compl_susp_ptr(compl_subg) = NULL;
		}
	      } /* if there are completion suspensions */
	    } /* else if not early completed */
	    ComplStkFrame = next_compl_frame(ComplStkFrame);
	  } /* while - for each subg in compl stack */
	  
	  /* find continuation, reclaim space if there are no completion
	   * suspensions and schedule answers (if any) */
	  if (breg == orig_breg) { 
	    /* no delays, mark all SCC as completed and do simplification */
#undef SHOULD_ACTUALLY_BE_LIKE_THIS_BUT_THE_DAMN_THING_DOES_NOT_WORK
#ifdef SHOULD_ACTUALLY_BE_LIKE_THIS_BUT_THE_DAMN_THING_DOES_NOT_WORK
	    ComplStackFrame compl_fr;

	    /* handle the leader; its answer list should be preserved */
	    mark_as_completed(subgoal);
	    /* handle most of the subgoals in the SCC -- leader is special */
	    compl_fr = next_compl_frame(cs_ptr);
	    while (compl_fr >= openreg) {
	      compl_subg = compl_subgoal_ptr(compl_fr);
	      mark_as_completed(compl_subg); 
	      reclaim_incomplete_table_structs(compl_subg,compl_fr);
	      next_CSF(compl_fr);
	    } /* while */
#else  
	    ComplStackFrame compl_fr;
	    for (compl_fr = cs_ptr; compl_fr >= openreg; next_CSF(compl_fr)) {
	      compl_subg = compl_subgoal_ptr(compl_fr);
	      mark_as_completed(compl_subg); 
	    } /* while */

	    /* reclaim all answer lists, but the one for the leader */
	    compl_fr = next_compl_frame(cs_ptr); 
	    while (compl_fr >= openreg) {
	      compl_subg = compl_subgoal_ptr(compl_fr);
	      reclaim_incomplete_table_structs(compl_subg,compl_fr);
	      next_CSF(compl_fr);
	    } /* while */
#endif	    
	    /* if subgoal has answers and these haven't been returned yet
	     * (when answers are returned, the answer list is reclaimed
	     * and set to 0, 1 or 2) */
	    if (has_answer_code(subgoal) &&
		(subg_answers(subgoal) > COND_ANSWERS)) {
	      
	      CPtr answer_template;
	      int template_size, attv_num;
	      
	      reclaim_incomplete_table_structs(subgoal,cs_ptr);
	      
	      openreg = prev_compl_frame(cs_ptr);
	      /* schedule return of answers */
	      {
		int tmp = int_val(cell(compl_hreg(cs_ptr)));
		get_var_and_attv_nums(template_size, attv_num, tmp);
	      }
	      answer_template = compl_hreg(cs_ptr) - template_size;
	      /* Now `answer_template' points to the mth term */
	      /* Initialize var_regs[] as the attvs in the call. */
#ifdef ATTR_VARS
	      num_vars_in_var_regs = -1;
	      if (attv_num > 0) {
		CPtr cptr;
		for (cptr = answer_template + template_size - 1;
		     cptr >= answer_template; cptr--) {
		  if (isattv(cell(cptr)))
		    var_regs[++num_vars_in_var_regs] = (CPtr) cell(cptr);
		}
		/* now num_vars_in_var_regs should be attv_num - 1 */
	      }
#endif
	      reg_arrayptr = reg_array - 1;
	      {
		int i;
		for (i = 0; i < template_size; i++) {
		  CPtr cptr = answer_template;
		  pushreg(*cptr);
		  answer_template++;
		}
	      }
	      
	      lpcreg = (byte *)subg_ans_root_ptr(subgoal);
	      /* backtrack to prev tabled subgoal after returning answers */
	      breg = tcp_prevbreg(breg);
	      /* since the trail condition registers are not reset in
		 tabletrust, they should be restored here */
	      restore_trail_condition_registers(breg);
	      delay_it = 1;
	      MoreMoreYesGimmeMore;
	    } /* if there are answers */   
	    else {  /* There are no answers to return
		       ------------------------------ */
	      reclaim_incomplete_table_structs(subgoal,cs_ptr);
	      /* there is nothing else to be done for this SCC */
	      breg = tcp_prevbreg(breg);
	      openreg = prev_compl_frame(cs_ptr); 
	    } /* no answers to return */
	  } /* if (breg == orig_breg) */
	}
    }
  else  /* if not leader */
    {
      chat_incremental_copy(subgoal);
      if (subg_in_cp_stack(subgoal))
	subg_cp_ptr(subgoal) = NULL;	/* preserve invariants */
      breg = tcp_prevbreg(breg); 
      /* since the trail condition registers are not reset in
	 tabletrust, they should be restored here */
      restore_trail_condition_registers(breg);
    }
  Fail1;
  MoreMoreYesGimmeMore;
} /* end of check_complete */
