/* File:      deref.h
** Author(s): Jiyang Xu, Terrance Swift, Kostis Sagonas
** Contact:   xsb-contact@cs.sunysb.edu
** 
** Copyright (C) The Research Foundation of SUNY, 1986, 1993-1998
** Copyright (C) ECRC, Germany, 1990
** 
** XSB is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** XSB is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with XSB; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** $Id: deref.h,v 1.2 2001/08/27 08:58:30 kostis Exp $
** 
*/


/* deref expects argument of type Cell */

#define deref(OP) deref2(OP, break)


#if (!defined(ATTR_VARS))
#define deref2(OP, ACTION)	\
  while (isref(OP)) {		\
    if (OP == follow(OP))	\
      ACTION;			\
    OP = follow(OP);		\
  }
#else
/* deref2 is changed to consider attributed variables */
#define deref2(op, ACTION) {				\
  while (isref(op)) {					\
    if (op == follow(op))				\
      ACTION;						\
    op = follow(op);					\
  }							\
  while (isattv(op)) {					\
    if (cell((CPtr) dec_addr(op)) == dec_addr(op)) 	\
      break; /* end of an attv */			\
    else {						\
      op = cell((CPtr) dec_addr(op));			\
      while (isref(op)) {				\
	if (op == follow(op))				\
          ACTION;					\
	op = follow(op);				\
      }							\
    }							\
  }							\
}
#endif

/*-----------------------------------------------------------------------*/

#define cptr_deref(OP) cptr_deref2(OP, break)

#if (!defined(ATTR_VARS))
#define cptr_deref2(OP,ACTION)	\
  while (isref(OP)) {		\
    if (OP == (CPtr)*(OP))	\
      { ACTION; }		\
    OP = (CPtr)*(OP);		\
}
#else
#define cptr_deref2(OP,ACTION) {			\
  while (isref(OP)) {					\
    if (OP == (CPtr)*(OP))				\
      { ACTION; }					\
    OP = (CPtr)*(OP);					\
  }							\
  while (isattv(OP)) {					\
    if (cell((CPtr)dec_addr(OP)) == dec_addr(OP)) {	\
      ACTION;						\
    } else {						\
      OP = (CPtr) cell((CPtr)dec_addr(OP));		\
      while (isref(OP)) {				\
	if (OP == (CPtr)*(OP)) { ACTION; }		\
	OP = (CPtr)*(OP);				\
      }							\
    }							\
  }							\
}
#endif

/*-----------------------------------------------------------------------*/

#define printderef(op) while (isref(op) && op > 0) { \
			 if (op==follow(op)) \
  			    break; \
			 op=follow(op); }

/*-----------------------------------------------------------------------*/
