/* File:      subp.h
** Author(s): Kostis Sagonas
** Contact:   xsb-contact@cs.sunysb.edu
** 
** Copyright (C) The Research Foundation of SUNY, 1986, 1993-1998
** Copyright (C) ECRC, Germany, 1990
** 
** XSB is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** XSB is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with XSB; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** $Id: subp.h,v 1.5 2003/09/04 14:44:36 kostis Exp $
** 
*/


/*======================================================================*/

extern int asynint_val;		/* 0 - no interrupt (or being processed) */
extern int asynint_code;	/* 0 means keyboard interrupt */

#ifdef ATTR_VARS
/* The following is exported this way, perhaps only temporarily */
extern Cell attv_interrupts[20480][2];
#endif

extern double realtime_count;

/*======================================================================*/

extern void intercept(Psc);
extern void init_interrupt(void);
extern void print_statistics(int);
extern void cleanup_open_tables(void);
extern void print_qatom(FILE *, char *);
extern void print_op(FILE *, char *, int);

extern int compare(Cell, Cell);
extern int key_compare(Cell, Cell);

extern byte *exception_handler(char *);
extern void xxx_segfault_quitter(int err);

extern Pair build_call(Psc);

#ifdef ATTR_VARS
extern void add_interrupt(Cell, Cell);
extern Cell build_interrupt_chain(void);
#endif

extern Psc  synint_proc(Psc, int);

#ifdef WIN_NT
extern boolean startInterruptThread(SOCKET);
#endif
