/* File:      sw_envs.h
** Author(s): Terry Swift, Rui Marques, Kostis Sagonas
** Contact:   xsb-contact@cs.sunysb.edu
** 
** Copyright (C) The Research Foundation of SUNY, 1998
** 
** XSB is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** XSB is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with XSB; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** $Id: sw_envs.h,v 1.2 2003/09/24 17:12:39 kostis Exp $
** 
*/


#define undo_bindings(TBREG) {	\
  register CPtr *xt1 = cp_trreg(TBREG); \
  table_undo_bindings(xt1); \
}

#include "binding.h"	/* needed because of the following ifdef */

#ifdef PRE_IMAGE_TRAIL
/*
 * If PRE_IMAGE_TRAIL is never used, the line of untrail2 in the following
 * macro should be changed to:
 * 	untrail(temp_trreg);
 */
#define table_undo_bindings(old_trreg) {	\
  register CPtr temp_trreg;                     \
  while (trreg > old_trreg) {	        	\
    temp_trreg = *(--trreg);		        \
    untrail2(trreg, (Cell)temp_trreg);		\
  }						\
}
#else
#define table_undo_bindings(old_trreg) {	\
  register CPtr temp_trreg;                     \
  while (trreg > old_trreg) {			\
    temp_trreg = *(--trreg);		        \
    untrail(temp_trreg);			\
  }						\
}
#endif

