/* File:      tables.h
** Author(s): Johnson, Swift, Sagonas, Rao, Freire
** Contact:   xsb-contact@cs.sunysb.edu
** 
** Copyright (C) The Research Foundation of SUNY, 1986, 1993-1998
** 
** XSB is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** XSB is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with XSB; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** $Id: tables.h,v 1.6 2003/06/30 15:00:22 daal8963 Exp $
** 
*/


#ifndef __TABLES_H__
#define __TABLES_H__
#include "cst.h"

/*===========================================================================*/

/*
 *                    Tabling Function Prototypes
 *                    ===========================
 */

void   table_call_search(TabledCallInfo *, CallLookupResults *);
BTNptr table_answer_search(SGFrame, 
			   int,
#if defined(ATTR_VARS) && !defined(CST_SUPPORT)
			   int,
#elif defined(CST_SUPPORT)
			   CST *,
#endif
			   CPtr, 
			   bool *);
void	table_consume_answer(
#if defined(CST_SUPPORT)
                             CST,
#else
			     BTNptr, 
#endif
			     int, 
			     int, 
			     CPtr);
ALNptr	table_retrieve_answers(SGFrame, SGFrame, CPtr);
void	table_complete_entry(SGFrame);

void	release_all_tabling_resources(void);

/*===========================================================================*/

#endif
