/* File:      tc_insts_xsb_i.h
** Author(s): Prasad Rao, Kostis Sagonas
** Contact:   xsb-contact@cs.sunysb.edu
** 
** Copyright (C) The Research Foundation of SUNY, 1986, 1993-1998
** 
** XSB is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** XSB is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with XSB; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** $Id: tc_insts_xsb_i.h,v 1.9 2003/11/23 21:00:50 kostis Exp $
** 
*/

/*----------------------------------------------------------------------*/
/* The following is the list of Trie-Code instructions.			*/
/*----------------------------------------------------------------------*/

  case trie_no_cp_str:
  trie_no_cp_str_label:
  {
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    unify_with_trie_str;
    non_ftag_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_try_str:
  trie_try_str_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    save_find_locx(ereg);
    tbreg = top_of_cpstack;
    save_trie_registers(tbreg);
    save_choicepoint(tbreg,ereg,(byte *)opfail,breg);
    breg = tbreg;
    hbreg = hreg;
    unify_with_trie_str;
    non_ftag_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_retry_str:
  trie_retry_str_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    tbreg = breg;
    restore_regs_and_vars(tbreg, CP_SIZE);
    cp_pcreg(breg) = (byte *)opfail;
    unify_with_trie_str;
    non_ftag_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_trust_str:
  trie_trust_str_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    tbreg = breg;
    restore_regs_and_vars(tbreg, CP_SIZE);
    breg = cp_prevbreg(breg);	/* Remove this CP */
    restore_trail_condition_registers(breg);
    unify_with_trie_str;
    non_ftag_lpcreg;
    MoreMoreYesGimmeMore;
  }

/*----------------------------------------------------------------------*/

  case trie_no_cp_numcon:
  trie_no_cp_numcon_label:
  {
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    unify_with_trie_numcon;
    reg_arrayptr--;
    non_ftag_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_try_numcon:
  trie_try_numcon_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    save_find_locx(ereg);
    tbreg = top_of_cpstack;
    save_trie_registers(tbreg);
    save_choicepoint(tbreg,ereg,(byte *)opfail,breg);
    breg = tbreg;
    hbreg = hreg;
    unify_with_trie_numcon;
    reg_arrayptr--;
    non_ftag_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_retry_numcon:
  trie_retry_numcon_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    tbreg = breg;
    restore_regs_and_vars(tbreg, CP_SIZE);
    cp_pcreg(breg) = (byte *) opfail;
    unify_with_trie_numcon;
    reg_arrayptr--;
    non_ftag_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_trust_numcon:
  trie_trust_numcon_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    tbreg = breg;
    restore_regs_and_vars(tbreg, CP_SIZE);
    breg = cp_prevbreg(breg);
    restore_trail_condition_registers(breg);
    unify_with_trie_numcon;
    reg_arrayptr--;
    non_ftag_lpcreg;
    MoreMoreYesGimmeMore;
  }

/*----------------------------------------------------------------------*/

  case trie_no_cp_numcon_succ:
  trie_no_cp_numcon_succ_label:
  {
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    unify_with_trie_numcon;
    reg_arrayptr--;
    proceed_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_try_numcon_succ:
  trie_try_numcon_succ_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    save_find_locx(ereg);
    tbreg = top_of_cpstack;
    save_trie_registers(tbreg);
    save_choicepoint(tbreg,ereg,(byte *)opfail,breg);
    breg = tbreg;
    hbreg = hreg;
    unify_with_trie_numcon;
    reg_arrayptr--;
    proceed_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_retry_numcon_succ:
  trie_retry_numcon_succ_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    tbreg = breg;
    restore_regs_and_vars(tbreg, CP_SIZE);
    cp_pcreg(breg) = (byte *) opfail;
    unify_with_trie_numcon;
    reg_arrayptr--;
    proceed_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_trust_numcon_succ:
  trie_trust_numcon_succ_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    tbreg = breg;
    restore_regs_and_vars(tbreg, CP_SIZE);
    breg = cp_prevbreg(breg);
    restore_trail_condition_registers(breg);
    unify_with_trie_numcon;
    reg_arrayptr--;
    proceed_lpcreg;
    MoreMoreYesGimmeMore;
  }

/*----------------------------------------------------------------------*/

  case trie_no_cp_var:
  trie_no_cp_var_label:
  {
    register BTNptr NodePtr;
    NodePtr = (BTNptr)lpcreg;
    num_vars_in_var_regs = DecodeTrieVar(opatom);
    var_regs[num_vars_in_var_regs] = (CPtr) *reg_arrayptr;
#ifdef DEBUG
    { 
      int i = num_vars_in_var_regs;
      if ((isref(var_regs[i])) &&
	  ((var_regs[i] < (CPtr)glstack.low) || (var_regs[i] >= hreg)) &&
	  ((var_regs[i] < top_of_localstk) || (var_regs[i] >= (CPtr) glstack.high))) {
	xxx_dbgmsg("tc_insts_xsb_i.h (no_cp): var reg assigned bad 0x%p %d 0x%p",
		   hreg, i, var_regs[i]); }
    } 
#endif
    reg_arrayptr--;
    next_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_try_var:
  trie_try_var_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    save_find_locx(ereg);
    tbreg = top_of_cpstack;
    save_trie_registers(tbreg);
    save_choicepoint(tbreg,ereg,(byte *)opfail,breg);
    breg = tbreg;
    hbreg = hreg;
    num_vars_in_var_regs = DecodeTrieVar(opatom);
    var_regs[num_vars_in_var_regs] = (CPtr) *reg_arrayptr;
#ifdef DEBUG
    {
      int i = num_vars_in_var_regs;
      if ((isref(var_regs[i])) &&
	  ((var_regs[i] < (CPtr)glstack.low) || (var_regs[i] >= hreg)) &&
	  ((var_regs[i] < top_of_localstk) || (var_regs[i] >= (CPtr) glstack.high))) {
	xxx_dbgmsg("tc_insts_xsb_i.h (try): var reg assigned bad 0x%p %d 0x%p",
		   hreg, i, var_regs[i]);
      }
    } 
#endif
    reg_arrayptr--;
    next_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_retry_var:
  trie_retry_var_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    tbreg = breg;
    restore_regs_and_vars(tbreg, CP_SIZE);
    cp_pcreg(breg) = (byte *) opfail;
    num_vars_in_var_regs = DecodeTrieVar(opatom);
    var_regs[num_vars_in_var_regs] = (CPtr) *reg_arrayptr;
#ifdef DEBUG
    {
      int i = num_vars_in_var_regs;
      if ((isref(var_regs[i])) &&
	  ((var_regs[i] < (CPtr)glstack.low) || (var_regs[i] >= hreg)) &&
	  ((var_regs[i] < top_of_localstk) || (var_regs[i] >= (CPtr) glstack.high))) {
	xxx_dbgmsg("tc_insts_xsb_i.h (retry): var reg assigned bad 0x%p %d 0x%p",
		   hreg, i, var_regs[i]);
      }
    } 
#endif
    reg_arrayptr--;
    next_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_trust_var:
  trie_trust_var_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    tbreg = breg;
    restore_regs_and_vars(tbreg, CP_SIZE);
    breg = cp_prevbreg(breg);	/* Remove this CP */
    restore_trail_condition_registers(breg);
    num_vars_in_var_regs = DecodeTrieVar(opatom);
    var_regs[num_vars_in_var_regs] = (CPtr) *reg_arrayptr;
#ifdef DEBUG
    {
      int i = num_vars_in_var_regs;
      if ((isref(var_regs[i])) &&
	  ((var_regs[i] < (CPtr)glstack.low) || (var_regs[i] >= hreg)) &&
	  ((var_regs[i] < top_of_localstk) || (var_regs[i] >= (CPtr) glstack.high))) {
	xxx_dbgmsg("tc_insts_xsb_i.h (trust): var reg assigned bad 0x%p %d 0x%p",
		   hreg, i, var_regs[i]);
      }
    } 
#endif
    reg_arrayptr--;
    next_lpcreg;
    MoreMoreYesGimmeMore;
  }

/*----------------------------------------------------------------------*/

  case trie_no_cp_val:
  trie_no_cp_val_label:
  {
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    unify_with_trie_val;
    next_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_try_val:
  trie_try_val_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;
    
    NodePtr = (BTNptr)lpcreg;
    save_find_locx(ereg);
    tbreg = top_of_cpstack;
    save_trie_registers(tbreg);
    save_choicepoint(tbreg,ereg,(byte *)opfail,breg);
    breg = tbreg;
    hbreg = hreg;
    unify_with_trie_val;
    next_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_retry_val:
  trie_retry_val_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    tbreg = breg;
    restore_regs_and_vars(tbreg, CP_SIZE);
    cp_pcreg(breg) = (byte *) opfail;
    unify_with_trie_val;
    next_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_trust_val:
  trie_trust_val_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    tbreg = breg;
    restore_regs_and_vars(tbreg, CP_SIZE);
    breg = cp_prevbreg(breg);	/* Remove this CP */
    restore_trail_condition_registers(breg);
    unify_with_trie_val;
    next_lpcreg;
    MoreMoreYesGimmeMore;
  }

/*----------------------------------------------------------------------*/

  case trie_no_cp_list:
  trie_no_cp_list_label:
  {
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    unify_with_trie_list;
    non_ftag_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_try_list:
  trie_try_list_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    save_find_locx(ereg);
    tbreg = top_of_cpstack;
    save_trie_registers(tbreg);
    save_choicepoint(tbreg,ereg,(byte *)opfail,breg);
    breg = tbreg;
    hbreg = hreg;
    unify_with_trie_list;
    non_ftag_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_retry_list:
  trie_retry_list_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    tbreg = breg;
    restore_regs_and_vars(tbreg, CP_SIZE);
    cp_pcreg(breg) = (byte *) opfail;
    unify_with_trie_list;
    non_ftag_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_trust_list:
  trie_trust_list_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    tbreg = breg;
    restore_regs_and_vars(tbreg, CP_SIZE);
    breg = cp_prevbreg(breg);	/* Remove this CP */
    restore_trail_condition_registers(breg);
    unify_with_trie_list;
    non_ftag_lpcreg;
    MoreMoreYesGimmeMore;
  }

/*----------------------------------------------------------------------*/
/* fail insts for deleted nodes - reclaim deleted returns at completion */
/*----------------------------------------------------------------------*/

  case trie_no_cp_fail:
  trie_no_cp_fail_label:
  {
    lpcreg = (byte *) &fail_inst;
    MoreMoreYesGimmeMore;
  }

  case trie_trust_fail:
  trie_trust_fail_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    tbreg = breg;
    restore_regs_and_vars(tbreg, CP_SIZE);
    breg = cp_prevbreg(breg);	/* Remove this CP */
    restore_trail_condition_registers(breg);
    lpcreg = (byte *) & fail_inst;
    MoreMoreYesGimmeMore;
  }

  case trie_try_fail:
  trie_try_fail_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    save_find_locx(ereg);
    tbreg = top_of_cpstack;
    save_trie_registers(tbreg);
    save_choicepoint(tbreg,ereg,(byte *)opfail,breg);
    breg = tbreg;
    hbreg = hreg;
    lpcreg = (byte *) & fail_inst;
    MoreMoreYesGimmeMore;
  }

  case trie_retry_fail:
  trie_retry_fail_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    tbreg = breg;
    restore_regs_and_vars(tbreg, CP_SIZE);
    cp_pcreg(breg) = (byte *) opfail;
    lpcreg = (byte *) & fail_inst;
    MoreMoreYesGimmeMore;
  }

/*----------------------------------------------------------------------*/
/* The following code, that handles hashing in coded tries, has been	*/
/* modified for garbage collection.  Choice points for hashes in tries,	*/
/* besides the usual trie argument registers (see file tr_code.h), also	*/
/* contain 3 fields with certain information about the hash bucket.	*/
/* The first and third of these fields are predefined integers and are	*/
/* now encoded as such.  The second field contains a malloc-ed address	*/
/* which is encoded as a tagged cell to prevent garbage collection from */
/* treating it as a reference either to a WAM stack or to a CHAT area.	*/
/*----------------------------------------------------------------------*/

/* Structure of the CPF created by hash_opcode:

             +-------------+
             |             |   LOW MEMORY
             |    Trail    |
             |             |
             |      |      |
             |      V      |
             |             |
             |             |
             |      ^      |
             |      |      |
             |             |
             |  CP Stack   |
             |             |
             |             |
             |=============|
             | Rest of CPF |--- Basic CPF (no argument registers)
             |-------------|
             | HASH index  | - last bucket explored
             |  ht header  | - ptr to HashTable Header structure
             | HASH_IS flag| - var/nonvar status of topmost term
             |-------------|    (the next to be unified with the trie)
             |     n+1     |_
             |reg_array[n] | \
             |      .      |  |
             |      .      |  |- Subterms to be unified with trie
             |      .      |  |
             |reg_array[0] |_/
             |-------------|
             |      m      |_
             | var_regs[m] | \
             |      .      |  |
             |      .      |  |- Variables encountered so far along trie path
             |      .      |  |   (m is -1 if no variables were encountered)
             | var_regs[0] |_/
             |=============|
             |      .      |
             |      .      |
             |      .      |    HIGH MEMORY
             +-------------+
*/

  case hash_opcode:
  hash_opcode_label:
  {
    register CPtr tbreg;
    register CPtr temp_ptr_for_hash;
    register BTNptr NodePtr;

    /*
     *  Under new trie structure, NodePtr is actually pointing at a
     *  Hash Table Header struct.
     */
    NodePtr = (BTNptr)lpcreg;
    save_find_locx(ereg);
    tbreg = top_of_cpstack;
    save_trie_registers(tbreg);
    temp_ptr_for_hash = (CPtr)*reg_arrayptr;
    cptr_deref(temp_ptr_for_hash);
    if (isref(temp_ptr_for_hash))
      cell(--tbreg) = makeint(HASH_IS_FREE);
    else
      cell(--tbreg) = makeint(HASH_IS_NOT_FREE);
    /*
     *  For normal trie nodes, this next CP value was given as the beginning
     *  of the hash table (bucket array).  With the new trie structure, I
     *  instead pass in the header, allowing access to all needed fields,
     *  including the bucket array.
     */
    cell(--tbreg) = makeatom(NodePtr);
    cell(--tbreg) = makeint(FIRST_HASH_NODE);
    save_choicepoint(tbreg,ereg,(byte *)&hash_handle_inst,breg);
    breg = tbreg;
    hbreg = hreg;
    lpcreg = (byte *) &hash_handle_inst;
    MoreMoreYesGimmeMore;
  }

/*
 *  Since this instruction is called immediately after 'hash_opcode' and
 *  is also backtracked to while exploring a bucket chain, a mechanism is
 *  needed to distinguish between the two cases.  Hence the use of the
 *  FIRST_HASH_NODE flag in the CPS.
 */
  case hash_handle:
  hash_handle_label:
  {
    register volatile int     hash_offset;
    register volatile BTHTptr hash_hdr;

    hash_offset = int_val(cell(breg+CP_SIZE));
    hash_hdr = (BTHTptr) atom_val(cell(breg+CP_SIZE+1));
    if ( int_val(cell(breg + CP_SIZE + 2)) == HASH_IS_NOT_FREE ) {
      /* Unify with nonvar */
      if ( (hash_offset != FIRST_HASH_NODE) &&
	   (hash_offset != NO_MORE_IN_HASH) ) {
	register CPtr tbreg = breg;
	restore_regs_and_vars(tbreg, CP_SIZE+3);
      }
      deref(*reg_arrayptr);
      if (isref(*reg_arrayptr)) { /* sanity check */
	xxx_exit("Error condition in instruction hash_handle\n");
      } else {
	int hashed_hash_offset;

	hash_nonvar_subterm(*reg_arrayptr,hash_hdr,hashed_hash_offset);
	if (hash_offset == FIRST_HASH_NODE) {
	  register BTHTptr *hash_base = (BTHTptr *) BTHT_BucketArray(hash_hdr);
	  if (*hash_base == NULL) { /* No Variables in hash table */
	    breg = cp_prevbreg(breg);   /* dealloc this CPF */
	    /* execute code of tries in this bucket */
	    if ((lpcreg = (byte *) *(hash_base + hashed_hash_offset)) == NULL)
	      Fail1;
	  }
	  else {   /* save hashed-to bucket, explore bucket 0 */
	    if ( (*(hash_base + hashed_hash_offset) == NULL) ||
		 (hashed_hash_offset == 0) )
	      breg = cp_prevbreg(breg);   /* dealloc this CPF */
	    else
	      cell(breg + CP_SIZE) = makeint(hashed_hash_offset);
	    lpcreg = (byte *) *hash_base;
	  }
	}
	else
	  if (hash_offset == hashed_hash_offset) {
	    register BTHTptr *hash_base = (BTHTptr *) BTHT_BucketArray(hash_hdr);
	    /* explore hashed-to bucket */
	    lpcreg = (byte *)*(hash_base + hash_offset);
	    breg = cp_prevbreg(breg);
	  }
	  else {
	    xxx_error("Hash Offset %d, HHO %d",hash_offset,hashed_hash_offset);
	    xxx_exit("Error condition in instruction hash_handle\n");
	  }
      }
    }
    else {  /* unification of trie with variable term */
      BTHTptr *hash_base = (BTHTptr *) BTHT_BucketArray(hash_hdr);
      find_next_nonempty_bucket(hash_hdr,hash_base,hash_offset);
      if (hash_offset == NO_MORE_IN_HASH) {
	breg = cp_prevbreg(breg);
	lpcreg = (byte *) cp_pcreg(breg);
      }
      else {
	if ( int_val(cell(breg+CP_SIZE)) != FIRST_HASH_NODE ) {
	  register CPtr tbreg = breg;
	  restore_regs_and_vars(tbreg, CP_SIZE+3);
	}
	lpcreg = (byte *) *(hash_base + hash_offset);
	cell(breg+CP_SIZE) = makeint(hash_offset);
      }
    }
    MoreMoreYesGimmeMore;
  }

/*----------------------------------------------------------------------*/

  case trie_proceed:	/* This is essentially a "proceed" */
  trie_proceed_label:
  {
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    proceed_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_root:      /* A no-op; begin processing with child */
  trie_root_label:
  {
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    lpcreg = (byte *) BTN_Child(NodePtr);
    MoreMoreYesGimmeMore;
  }

/*
 * This is the embedded-trie instruction which is placed in the root of
 * asserted tries.  It looks a lot like both "return_table_code", which
 * prepares the engine to walk an answer trie, and "get_calls", which
 * prepares the engine to walk a call trie.  Maybe there's a way to
 * "unify" these operations now that all tries contain root nodes.
 */
  case trie_assert_inst:
  trie_assert_inst_label:
  {
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    if (Child(NodePtr) != NULL) {
      int i;
      Psc psc;
      
      psc = DecodeTriePSC(BTN_Symbol(NodePtr));
      reg_arrayptr = reg_array-1;
      num_vars_in_var_regs = -1;
      for (i = get_arity(psc); i >= 1; i--) { pushreg(*(rreg+i)); }
      lpcreg = (byte *) Child(NodePtr);
    }
    else
      lpcreg = (byte *) &fail_inst;
    MoreMoreYesGimmeMore;
  }

/*----------------------------------------------------------------------*/

#ifdef ATTR_VARS
  case trie_no_cp_attv:
  trie_no_cp_attv_label:
  {
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    unify_with_trie_attv;
    next_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_try_attv:
  trie_try_attv_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    NodePtr = (BTNptr)lpcreg;
    save_find_locx(ereg);
    tbreg = top_of_cpstack;
    save_trie_registers(tbreg);
    save_choicepoint(tbreg,ereg,(byte *)opfail,breg);
    breg = tbreg;
    hbreg = hreg;
    unify_with_trie_attv;
    next_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_retry_attv:
  trie_retry_attv_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    /* fprintf(stderr, "In trie_retry_attv...\n"); */
    NodePtr = (BTNptr)lpcreg;
    tbreg = breg;
    restore_regs_and_vars(tbreg, CP_SIZE);
    cp_pcreg(breg) = (byte *) opfail;
    unify_with_trie_attv;
    next_lpcreg;
    MoreMoreYesGimmeMore;
  }

  case trie_trust_attv:
  trie_trust_attv_label:
  {
    register CPtr tbreg;
    register BTNptr NodePtr;

    /* fprintf(stderr, "In trie_trust_attv...\n"); */
    NodePtr = (BTNptr)lpcreg;
    tbreg = breg;
    restore_regs_and_vars(tbreg, CP_SIZE);
    breg = cp_prevbreg(breg);	/* Remove this CP */
    restore_trail_condition_registers(breg);
    unify_with_trie_attv;
    next_lpcreg;
    MoreMoreYesGimmeMore;
  }
#endif

/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/* The following is the list of CST Code instructions.                  */
/*----------------------------------------------------------------------*/

#if defined(CST_SUPPORT)
  case cst_continue:
  cst_continue_label:
  {
      register CPtr tbreg;
      register CST  node;

      node = (CST)lpcreg;
      
      if(node->left != NULL)
      {
	  if(node->right != NULL)
	  {
	      save_find_locx(ereg);
	      tbreg = top_of_cpstack;
	      save_cst_vars(tbreg);
	      save_trie_registers(tbreg);
	      save_choicepoint(tbreg,ereg,(byte *)node->right,breg);
	      breg = tbreg;
	      hbreg = hreg;
	  }
	  lpcreg = (byte *)node->left;
      }else{
	  if(node->right != NULL)
	      lpcreg = (byte *)node->right;
	  else
	      lpcreg = (byte *) &fail_inst;
      }
      
      MoreMoreYesGimmeMore;
  }

  case cst_continue_cp:
  cst_continue_cp_label:
  {
      register CPtr tbreg;
      register CST  node;

      node = (CST)lpcreg;
      tbreg = breg;
      restore_regs_and_vars(tbreg, CP_SIZE);
      restore_cst_vars(tbreg);
      breg = cp_prevbreg(breg);
      restore_trail_condition_registers(breg);
      
      if(node->left != NULL)
      {
	  if(node->right != NULL)
	  {
	      save_find_locx(ereg);
	      tbreg = top_of_cpstack;
	      save_cst_vars(tbreg);
	      save_trie_registers(tbreg);
	      save_choicepoint(tbreg,ereg,(byte *)node->right,breg);
	      breg = tbreg;
	      hbreg = hreg;
	  }
	  lpcreg = (byte *)node->left;
      }else{
	  if(node->right != NULL)
	      lpcreg = (byte *)node->right;
	  else
	      lpcreg = (byte *) &fail_inst;
      }
      
      MoreMoreYesGimmeMore;
  }

  case cst_return:
  cst_return_label:
  {
      register CPtr tbreg;
      register CST  node;

      node = (CST)lpcreg;
      Last_CST_Nod_Sav = node;

      if(node->right != NULL)
      {
	  save_find_locx(ereg);
	  tbreg = top_of_cpstack;
	  save_cst_vars(tbreg);
	  save_trie_registers(tbreg);
	  save_choicepoint(tbreg,ereg,(byte *)node->right,breg);
	  breg = tbreg;
	  hbreg = hreg;
      }
      if(node->left != NULL)
      {
	  save_find_locx(ereg);
	  tbreg = top_of_cpstack;
	  save_cst_vars(tbreg);
	  save_trie_registers(tbreg);
	  save_choicepoint(tbreg,ereg,(byte *)node->left,breg);
	  breg = tbreg;
	  hbreg = hreg;
      }
      
      CST_return_answer(node, 
			cst_last_answer_return_array,
			cst_last_answer_return_arraysize,
			cst_last_answer_return_array_goes_up);
      cst_op_proceed_lpcreg;
      MoreMoreYesGimmeMore;
  }
  
  case cst_return_cp:
  cst_return_cp_label:
  {
      register CPtr tbreg;
      register CST  node;

      node = (CST)lpcreg;
      tbreg = breg;
      restore_regs_and_vars(tbreg, CP_SIZE);
      restore_cst_vars(tbreg);
      breg = cp_prevbreg(breg);
      restore_trail_condition_registers(breg);
      Last_CST_Nod_Sav = node;

      if(node->right != NULL)
      {
	  save_find_locx(ereg);
	  tbreg = top_of_cpstack;
	  save_cst_vars(tbreg);
	  save_trie_registers(tbreg);
	  save_choicepoint(tbreg,ereg,(byte *)node->right,breg);
	  breg = tbreg;
	  hbreg = hreg;
      }
      if(node->left != NULL)
      {
	  save_find_locx(ereg);
	  tbreg = top_of_cpstack;
	  save_cst_vars(tbreg);
	  save_trie_registers(tbreg);
	  save_choicepoint(tbreg,ereg,(byte *)node->left,breg);
	  breg = tbreg;
	  hbreg = hreg;
      }
      
      CST_return_answer(node, 
			cst_last_answer_return_array,
			cst_last_answer_return_arraysize,
			cst_last_answer_return_array_goes_up);
      cst_op_proceed_lpcreg;
      MoreMoreYesGimmeMore;
  }

  case cst_remove_cp:
  cst_remove_cp_label:
  {
      breg = cp_prevbreg(breg);   /* Remove this CP */
      restore_trail_condition_registers(breg);
      Fail1;
      MoreMoreYesGimmeMore;
  }
#endif
