/* File:      timer_xxx.c
** Author(s): Songmei Yu, Michael Kifer
** Contact:   xsb-contact@cs.sunysb.edu
**
** Copyright (C) The Research Foundation of SUNY, 1999
** 
** XSB is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** XSB is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with XSB; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** $Id: timer_xsb.c,v 1.6 2005/10/12 13:04:10 kostis Exp $
** 
*/


#include "xxx_config.h"

#ifdef WIN_NT
#include <windows.h>
#include <winuser.h>
#endif
#include <setjmp.h> 

#include "timer_xsb.h"

/* To set a timeout, do this:
   if (CHECK_TIMER_SET) {
      // if timeout was set in Prolog using set_timeout/1
      SETALARM;
      if (!TIMERJMP) {
	SET_TIMER;
	.... actions if NO timeout...;
        TURNOFFALARM;
      } else {
        .... actions if timeout .....
        TURNOFFALARM;
      }
   } else {
     .... actions when timeout is not set ....
   }
*/

#ifdef WIN_NT
jmp_buf xxx_timer_env;
#else
sigjmp_buf xxx_timer_env;
#endif

#ifdef WIN_NT
VOID CALLBACK xxx_timer_handler(HWND wind, UINT msg, UINT eventid, DWORD time)
{
  longjmp(xxx_timer_env,1);
}
#else
/* SIGALRM handler for controlling time outs */
void xxx_timer_handler(int sig)
{
  sig = 1; /* dummy assignment so that the sig argument is somehow used */
  siglongjmp(xxx_timer_env,sig);
}
#endif
