/* File:      tr_utils.h
** Author(s): Prasad Rao, Kostis Sagonas
** Contact:   xsb-contact@cs.sunysb.edu
** 
** Copyright (C) The Research Foundation of SUNY, 1986, 1993-1998
** 
** XSB is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** XSB is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with XSB; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** $Id: tr_utils.h,v 1.7 2003/12/20 10:48:26 kostis Exp $
** 
*/

extern BTNptr *Set_ArrayPtr;

extern long    new_trie(void);
extern void    init_newtrie(void);
extern SGFrame get_call(Cell,Cell *);
extern void    undelete_branch(BTNptr);
extern void    trie_dispose(int,BTNptr);
extern void    delete_interned_trie(int);
extern bool    trie_intern(Cell,int,Cell);
extern void    safe_delete_branch(BTNptr);
extern Cell    build_ret_term(int,Cell[]);
extern SGFrame get_subgoal_ptr(Cell,TIFptr);
extern void    reclaim_del_ret_list(SGFrame);
extern void    delete_return(
#if defined(CST_SUPPORT)
    CST,
#else
    BTNptr,
#endif
    SGFrame);
extern void    delete_branch(BTNptr,BTNptr *);
extern void    delete_predicate_table(TIFptr);
extern void    incomplete_retskel_subgoal(void);
extern bool    trie_interned(Cell,int,Cell,Cell);
extern bool    has_unconditional_answers(SGFrame);

/* PERHAPS A BETTER WAY OF DOING THE FOLLOWING SHOULD BE FOUND */
#if defined(CST_SUPPORT)
typedef struct {
    BTNptr  btn;
    CST     cst;
} btn_cst_tuple;

extern btn_cst_tuple
#else
extern BTNptr
#endif
               variant_trie_lookup(int,CPtr,BTNptr,Cell[]);
