:- compiler_options([xpp_on]).
#include "socket_defs_xsb.h"
#include "timer_defs_xsb.h"
#include "char_defs.h"


:- import 
     socket/2, socket_connect/4, socket_set_option/3,
     socket_close/2, socket_recv/3, socket_send/3  from socket.
:- import file_close/1 from file_io.


%% machine where server is running
machine(localhost).
%% Try something else:
%%machine(compserv1).

%% Port on which the server is listening
%% Server must bind to this port
xsb_port(6022).

client :-
  writeln('started client...'),
  socket(Sockfd0, ErrCode),
  (ErrCode == SOCK_OK
  ->  socket_set_option(Sockfd0,linger,SOCK_NOLINGER),
      machine(IPAddressOrHostname),
      xsb_port(XSB_port),
      socket_connect(Sockfd0 ,XSB_port, IPAddressOrHostname, Ecode2),
      writeln(socket_connect1(Sockfd0,XSB_port,IPAddressOrHostname,Ecode2)),
      (Ecode2 == SOCK_OK
      -> writeln('connected to server...')
      ;  writeln('Cannot connect to server'),
	 socket_close(Sockfd0,_),
	 fail
      ),

      %% Socket for reading replies
      socket(Sockfd1, Error2),
      (Error2 == SOCK_OK
      ->  socket_set_option(Sockfd1,linger,SOCK_NOLINGER),
	  socket_connect(Sockfd1, XSB_port, IPAddressOrHostname, Ecode3),
	  writeln(socket_connect(Sockfd1,XSB_port,IPAddressOrHostname,Ecode3)),
	  client_loop(Sockfd0, Sockfd1)
      ;   writeln('Can''t read from the server'),
          socket_close(Sockfd0,_),
          fail
      )
  ;  writeln('Can''t open socket to the server.')
  ).
      


client_loop(Sockfd0, Sockfd1) :-  
  nl, write('Please enter goal: g(X). or h(X).  Type e. to finish. Goal: '), 
  read_canonical(Goal),
  ((Goal == 'e' ; Goal == end_of_file) ->
      !,
      socket_close(Sockfd0, _),
      socket_close(Sockfd1, _),
      writeln('Exiting.'), true
  ;   
      nl,writeln(send(Goal)),
      fmt_write_string(GoalStr, '%S.', arg(Goal)),
      socket_send(Sockfd0, GoalStr, _Er), 
      writeln('Answers: '),
      repeat,
      socket_recv(Sockfd1, AnswerStr,_),
      file_open(AnswerStr,sr,IOport),
      file_read(IOport,Answer),
      file_close(IOport),
      (Answer==end_of_file 
      -> !, true
      ;  (   Answer == 'end' 
	 ->  client_loop(Sockfd0, Sockfd1)
	 ;   
	      write('    '),
	      write(Answer), nl, 
	      fail
	  )
      )
   ).
 
